      PARAMETER (NX=202,IX=51)
      REAL G(NX,IX),C(NX,NX),Q(NX,NX),R(NX,NX),T(NX,IX)
      REAL*8 CC(NX,NX),QQ(NX,NX),RR(NX,NX),
     +       D1(NX,NX),D2(NX,NX),D3(NX,NX)

      CALL RDDAT (NX,IX,G)
C     If the following subroutine NORM is called, calculation will be
C     performed for correlation instead of covariance.
      CALL NORM  (NX,IX,G)
      CALL CVAR  (NX,IX,G,C)
      CALL CONV1 (NX,NX,C,CC)
      CALL EIGEN (NX,CC,QQ,RR,100,D1,D2,D3)
      CALL CONV2 (NX,NX,QQ,Q)
      CALL CONV2 (NX,NX,RR,R)
      CALL SCORE (NX,IX,G,Q,T)
      CALL WRRAT (NX,R)
      CALL WREOF (NX,Q)
      CALL WRPC  (NX,IX,T)
      STOP
      END

C ========================================

      SUBROUTINE RDDAT (NX,IX,G)
      REAL G(NX,IX)
      OPEN(10,FILE='input.dat',
     +     STATUS='OLD',FORM='UNFORMATTED',
     +     ACCESS='DIRECT',RECL=4*(NX*IX),ERR=99)
      READ(10,REC=1,ERR=99) G
      CLOSE(10)
      RETURN
   99 CLOSE(10)
      WRITE(6,*) 'Can not read file.'
      STOP
      END

      SUBROUTINE WRRAT (NX,R)
      REAL R(NX,NX)
      CHARACTER OUTFL*80
      OUTFL = 'ratio.dat'
      OPEN(10,FILE=OUTFL,STATUS='UNKNOWN',FORM='FORMATTED',ERR=99)
      WRITE(10,'(A14)') ' No. Ratio [%]'
  101 FORMAT(I4,1X,F9.3)
        SUM = 0.0E0
      DO 11 N=1,NX
        SUM = SUM + R(N,N)
   11 CONTINUE
      DO 12 N=1,NX
        WRITE(10,101,ERR=99) N,1.0E2*R(N,N)/SUM
   12 CONTINUE
      CLOSE(10)
      WRITE(6,*) "Output was written to file 'ratio.dat'."
      RETURN
   99 CLOSE(10)
      WRITE(6,*) "Can not write data to file 'ratio.dat'."
      STOP
      END

      SUBROUTINE WREOF (NX,G)
      REAL G(NX,NX)
      OPEN(10,FILE='eof.dat',
     +     STATUS='UNKNOWN',FORM='UNFORMATTED',
     +     ACCESS='DIRECT',RECL=4*(NX*NX),ERR=99)
      WRITE(10,REC=1,ERR=99) G
      CLOSE(10)
      WRITE(6,*) "Output was written to file 'eof.dat'."
      RETURN
   99 CLOSE(10)
      WRITE(6,*) "Can not write data to file 'eof.dat'."
      STOP
      END

      SUBROUTINE WRPC (NX,IX,G)
      REAL G(NX,IX)
      OPEN(10,FILE='pc.dat',
     +     STATUS='UNKNOWN',FORM='UNFORMATTED',
     +     ACCESS='DIRECT',RECL=4*(NX*IX),ERR=99)
      WRITE(10,REC=1,ERR=99) G
      CLOSE(10)
      WRITE(6,*) "Output was written to file 'pc.dat'."
      RETURN
   99 CLOSE(10)
      WRITE(6,*) "Can not write data to file 'pc.dat'."
      STOP
      END

      SUBROUTINE CONV1 (NX,IX,G,GG)
      REAL G(NX,IX)
      REAL*8 GG(NX,IX)
      DO 11 I=1,IX
      DO 12 N=1,NX
        GG(N,I) = DBLE(G(N,I))
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE CONV2 (NX,IX,GG,G)
      REAL G(NX,IX)
      REAL*8 GG(NX,IX)
      DO 11 I=1,IX
      DO 12 N=1,NX
        G(N,I) = REAL(GG(N,I))
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ==================================================

      SUBROUTINE NORM (NX,IX,G)
      REAL G(NX,IX)
      DO 11 N=1,NX
        S1 = 0.0E0
        S2 = 0.0E0
      DO 21 I=1,IX
        S1 = S1 + G(N,I)
        S2 = S2 + G(N,I)**2
   21 CONTINUE
        A = S1 / REAL(IX)
        D = S2 / REAL(IX) - A**2
        SD = SQRT(D)
      DO 22 I=1,IX
        G(N,I) = (G(N,I) - A) / SD
   22 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE CVAR (NX,IX,G,C)
      REAL G(NX,IX),C(NX,NX)
      DO 11 M=1,NX
      DO 12 L=1,M
        SX = 0.0E0
        SY = 0.0E0
        SX2 = 0.0E0
        SY2 = 0.0E0
        SXY = 0.0E0
      DO 21 I=1,IX
        SX = SX + G(L,I)
        SY = SY + G(M,I)
        SX2 = SX2 + G(L,I)**2
        SY2 = SY2 + G(M,I)**2
        SXY = SXY + G(L,I)*G(M,I)
   21 CONTINUE
        AX = SX / REAL(IX)
        AY = SY / REAL(IX)
        C(L,M) = (SXY - REAL(IX)*AX*AY) / REAL(IX)
        IF (L.NE.M) C(M,L) = C(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE SCORE (NX,IX,G,P,T)
      REAL G(NX,IX),P(NX,NX),T(NX,IX)
      DO 11 I=1,IX
      DO 12 N=1,NX
        T(N,I) = 0.0E0
      DO 21 L=1,NX
        T(N,I) = T(N,I) + P(L,N) * G(L,I)
   21 CONTINUE
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ==================================================

      SUBROUTINE EIGEN (MX,A,Q,R,LX,QQ,QAQ,TMP)
      REAL*8 A(MX,MX),Q(MX,MX),R(MX,MX)
      REAL*8 QQ(MX,MX),QAQ(MX,MX),TMP(MX,MX)
C     MX : Size of the matrix
C     A  : Input matrix
C     Q  : Orthogonal matrix
C     R  : Upper triangular matrix
C     LX : Repetition number of QR decomposition
C     QQ,QAQ,TMP : Dummy matrices
      CALL UNIT (MX,QQ)
      CALL COPY (MX,QAQ,A)
      DO 11 L=1,LX
        CALL QRD  (MX,QAQ,Q,R)
        CALL PROD (MX,QAQ,R,Q)
        CALL COPY (MX,TMP,QQ)
        CALL PROD (MX,QQ,TMP,Q)
   11 CONTINUE
      CALL COPY (MX,Q,QQ)
      RETURN
      END

C ==================================================

      SUBROUTINE QRD (MX,A,Q,R)
      REAL*8 A(MX,MX),Q(MX,MX),R(MX,MX)
C     MX : Size of the matrix
C     A  : Input matrix
C     Q  : Orthogonal matrix
C     R  : Upper triangular matrix
      DO 11 N=1,MX
      DO 12 NN=1,N-1
        R(NN,N) = 0.0D0
      DO 13 M=1,MX
        R(NN,N) = R(NN,N) + A(M,N) * Q(M,NN)
   13 CONTINUE
   12 CONTINUE
        R(N,N) = 0.0D0
      DO 14 M=1,MX
        Q(M,N) = A(M,N)
      DO 15 NN=1,N-1
        Q(M,N) = Q(M,N) - Q(M,NN) * R(NN,N)
   15 CONTINUE
        R(N,N) = R(N,N) + Q(M,N)**2
   14 CONTINUE
        R(N,N) = DSQRT(R(N,N))
      DO 16 M=1,MX
        Q(M,N) = Q(M,N) / R(N,N)
   16 CONTINUE
      DO 17 NN=N+1,MX
        R(NN,N) = 0.0D0
   17 CONTINUE
   11 CONTINUE
      RETURN
      END

C ==================================================

      SUBROUTINE COPY (MX,A,B)
      REAL*8 A(MX,MX),B(MX,MX)
      DO 11 N=1,MX
      DO 12 M=1,MX
        A(M,N) = B(M,N)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE UNIT (MX,A)
      REAL*8 A(MX,MX)
      DO 11 N=1,MX
      DO 12 M=1,MX
      IF (M.EQ.N) THEN
        A(M,N) = 1.0D0
      ELSE
        A(M,N) = 0.0D0
      ENDIF
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE PROD (MX,A,B,C)
      REAL*8 A(MX,MX),B(MX,MX),C(MX,MX)
C     MX  : Size of the matrix
C     A   : Product of the two matrices (B and C).
C     B,C : Input matrix
      DO 11 N=1,MX
      DO 12 M=1,MX
        A(M,N) = 0.0D0
      DO 13 L=1,MX
        A(M,N) = A(M,N) + B(M,L) * C(L,N)
   13 CONTINUE
   12 CONTINUE
   11 CONTINUE
      RETURN
      END
