      SUBROUTINE EGN22 (A,V1R,V1I,V2R,V2I,C1R,C1I,C2R,C2I)
      REAL*8 A(2,2),V1R(2),V1I(2),V2R(2),V2I(2),C1R,C1I,C2R,C2I,C,DSQRT
C     MX  : Size of the matrix
C     A   : Input matrix
C     V1R : Real part of 1st eigen vector
C     V1I : Imagenary part of 1st eigen vector
C     V2R : Real part of 2nd eigen vector
C     V2I : Imagenary part of 2nd eigen vector
C     C1R : Real part of 1st eigen value
C     C1I : Imagenary part of 1st eigen value
C     C2R : Real part of 2nd eigen value
C     C2I : Imagenary part of 2nd eigen value
      D = (A(1,1)-A(2,2))**2+0.4D1*A(2,1)*A(1,2)
      IF (D.GE.0.0D0) THEN
        C1R = 0.5D0*(A(1,1)+A(2,2)) + DSQRT(0.25D0*D)
        C1I = 0.0D0
        C2R = 0.5D0*(A(1,1)+A(2,2)) - DSQRT(0.25D0*D)
        C2I = 0.0D0
      ELSE
        C1R = 0.5D0*(A(1,1)+A(2,2))
        C1I = + DSQRT(-0.25D0*D)
        C2R = 0.5D0*(A(1,1)+A(2,2))
        C2I = - DSQRT(-0.25D0*D)
      ENDIF
        V1R(1) = A(1,2)
        V1I(1) = 0.0D0
        V1R(2) = C1R - A(1,1)
        V1I(2) = C1I
        C = 1.0D0/DSQRT(V1R(1)**2+V1I(1)**2+V1R(2)**2+V1I(2)**2)
        V1R(1) = C * V1R(1)
        V1I(1) = C * V1I(1)
        V1R(2) = C * V1R(2)
        V1I(2) = C * V1I(2)
        V2R(1) = A(1,2)
        V2I(1) = 0.0D0
        V2R(2) = C2R - A(1,1)
        V2I(2) = C2I
        C = 1.0D0/DSQRT(V2R(1)**2+V2I(1)**2+V2R(2)**2+V2I(2)**2)
        V2R(1) = C * V2R(1)
        V2I(1) = C * V2I(1)
        V2R(2) = C * V2R(2)
        V2I(2) = C * V2I(2)
      RETURN
      END
