      SUBROUTINE ZERO (MX,A)
      REAL A(MX,MX)
      DO 11 N=1,MX
      DO 12 M=1,MX
        A(M,N) = 0.0E0
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE UNIT (MX,A)
      REAL A(MX,MX)
      DO 11 N=1,MX
      DO 12 M=1,MX
      IF (M.EQ.N) THEN
        A(M,N) = 1.0E0
      ELSE
        A(M,N) = 0.0E0
      ENDIF
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE COPY (MX,G,GG)
      REAL G(MX,MX),GG(MX,MX)
      DO 11 N=1,MX
      DO 12 M=1,MX
        GG(M,N) = G(M,N)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE MULT (MX,C,A,B)
      REAL A(MX,MX),B(MX,MX)
C     MX  : Size of the matrix
C     A   : Matrix multiplied by C
C     B   : Input matrix
      DO 11 N=1,MX
      DO 12 M=1,MX
        A(M,N) = C * B(M,N)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE SUM (MX,A,B,C)
      REAL A(MX,MX),B(MX,MX),C(MX,MX)
C     MX  : Size of the matrix
C     A   : Summation of two matrices (B and C)
C     B,C : Input matrix
      DO 11 N=1,MX
      DO 12 M=1,MX
        A(M,N) = B(M,N) + C(M,N)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE PROD (MX,A,B,C)
      REAL A(MX,MX),B(MX,MX),C(MX,MX)
C     MX  : Size of the matrix
C     A   : Product of two matrices (B and C)
C     B,C : Input matrix
      DO 11 N=1,MX
      DO 12 M=1,MX
        A(M,N) = 0.0E0
      DO 13 L=1,MX
        A(M,N) = A(M,N) + B(M,L) * C(L,N)
   13 CONTINUE
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE TRANS (MX,A,B)
      REAL A(MX,MX),B(MX,MX)
C     MX : Size of the matrix
C     A  : Output matrix
C     B  : Input matrix
      DO 11 N=1,MX
      DO 12 M=1,MX
        A(M,N) = B(N,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE NORM (MX,A,B)
      REAL A(MX),B(MX)
C     MX  : Size of the vector
C     A   : Output vector
C     B   : Input vector
        S = 0.0E0
      DO 11 M=1,MX
        S = S + B(M)**2
   11 CONTINUE
        C = 1.0E0 / SQRT(S)
      DO 12 M=1,MX
        A(M) = C * B(M)
   12 CONTINUE
      RETURN
      END

      SUBROUTINE VPRD (MX,A,B,C)
      REAL A(MX),B(MX,MX),C(MX)
C     MX  : Size of the matrix
C     A   : Product of a matrix and a vector (B and C)
C     B   : Input matrix
C     C   : Input vector
      DO 11 M=1,MX
        A(M) = 0.0E0
      DO 12 L=1,MX
        A(M) = A(M) + B(M,L) * C(L)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      REAL FUNCTION VABS (MX,A)
      REAL A(MX)
C     MX  : Size of the vector
C     A   : Input vector
        S = 0.0E0
      DO 11 M=1,MX
        S = S + A(M)**2
   11 CONTINUE
        VABS = SQRT(S)
      RETURN
      END

      REAL FUNCTION DPRD (MX,A,B)
      REAL A(MX),B(MX)
C     MX  : Size of the vector
C     A,B : Input vectors
        DPRD = 0.0E0
      DO 11 M=1,MX
        DPRD = DPRD + A(M)*B(M)
   11 CONTINUE
      RETURN
      END

      SUBROUTINE OPRD (MX,A,B,C)
      REAL A(MX),B(MX),C(MX)
C     MX  : Size of the vector
C     A   : Outer product of two vectors (B and C)
C     B,C : Input vector
      DO 11 M=1,MX
      M1=M-1
      IF (M1.LT. 1) M1= M1+MX
      M2=M+1
      IF (M2.GT.MX) M2= M2-MX
        A(M) = B(M1) * C(M2) - B(M2) * C(M1)
   11 CONTINUE
      RETURN
      END
