      SUBROUTINE INVMTX (IX,A,B,D)
      REAL A(IX,IX),B(IX,IX),D(IX,IX)
C     IX : Size of the matrix
C     A  : Input matrix
C     B  : Inverse matrix
C     D  : Dummy matrix
      CALL COPY (IX,D,A)
      CALL UNIT (IX,B)
      DO 11 I=1,IX
        C = 1.0E0 / D(I,I)
        CALL ETRL2 (IX,I,C,D)
        CALL ETRL2 (IX,I,C,B)
      DO 12 II=1,IX
      IF (II.NE.I) THEN
        C = - D(II,I)
        CALL ETRL3 (IX,II,I,C,D)
        CALL ETRL3 (IX,II,I,C,B)
      ENDIF
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ==================================================

      SUBROUTINE ETRL1 (IX,I1,I2,A)
      REAL A(IX,IX)
C     Left elementary transformation (1)
C     Change lines.
      DO 11 II=1,IX
        C = A(I1,II)
        A(I1,II) = A(I2,II)
        A(I2,II) = C
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ETRL2 (IX,I,C,A)
      REAL A(IX,IX)
C     Left elementary transformation (2)
C     Multiply a line by a parameter.
      DO 11 II=1,IX
        A(I,II) = C * A(I,II)
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ETRL3 (IX,I1,I2,C,A)
      REAL A(IX,IX)
C     Left elementary transformation (3)
C     Add another line multiplied by a parameter to a line.
      DO 11 I=1,IX
        A(I1,I) = A(I1,I) + C * A(I2,I)
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ETRR1 (IX,I1,I2,A)
      REAL A(IX,IX)
C     Right elementary transformation (1)
C     Change columns.
      DO 11 II=1,IX
        C = A(II,I1)
        A(II,I1) = A(II,I2)
        A(II,I2) = C
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ETRR2 (IX,I,C,A)
      REAL A(IX,IX)
C     Right elementary transformation (2)
C     Multiply a column by a parameter.
      DO 11 II=1,IX
        A(II,I) = C * A(II,I)
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ETRR3 (IX,I1,I2,C,A)
      REAL A(IX,IX)
C     Right elementary transformation (3)
C     Add another column multiplied by a parameter to a column.
      DO 11 I=1,IX
        A(I,I1) = A(I,I1) + C * A(I,I2)
   11 CONTINUE
      RETURN
      END

C ==================================================

      SUBROUTINE COPY (IX,A,B)
      REAL A(IX,IX),B(IX,IX)
      DO 11 N=1,IX
      DO 12 M=1,IX
        A(M,N) = B(M,N)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE UNIT (MX,A)
      REAL A(MX,MX)
      DO 11 N=1,MX
      DO 12 M=1,MX
      IF (M.EQ.N) THEN
        A(M,N) = 1.0E0
      ELSE
        A(M,N) = 0.0E0
      ENDIF
   12 CONTINUE
   11 CONTINUE
      RETURN
      END
