      SUBROUTINE EIGEN (MX,A,B,C,P,LX,TMP)
      REAL*8 A(MX,MX),B(MX),TMP(MX),C,P,VABS,DPRD,DSQRT
C     MX  : Size of the matrix
C     A   : Input matrix
C     B   : First eigen vector
C     C   : First eigen value
C     P   : Normalized inner product
C     LX  : Repetition number of QR decomposition
C     TMP : Dummy vector
      DO 10 M=1,MX
        B(M) = 1.0D0 / DSQRT(DBLE(MX))
   10 CONTINUE
      DO 11 L=1,LX
        CALL VPRD (MX,TMP,A,B)
        CALL NORM (MX,B,TMP)
   11 CONTINUE
        CALL VPRD (MX,TMP,A,B)
        P = DPRD(MX,TMP,B)
        C = VABS(MX,TMP) / VABS(MX,B)
        P = P / C
        IF (P.LT.0.0D0) THEN
          C = - C
          P = - P
        ENDIF
      RETURN
      END

C ==================================================

      SUBROUTINE NORM (MX,A,B)
      REAL*8 A(MX),B(MX),S,C,DSQRT
C     MX  : Size of the vector
C     A   : Output vector
C     B   : Input vector
        S = 0.0D0
      DO 11 M=1,MX
        S = S + B(M)**2
   11 CONTINUE
        C = 1.0D0 / DSQRT(S)
      DO 12 M=1,MX
        A(M) = C * B(M)
   12 CONTINUE
      RETURN
      END

      SUBROUTINE VPRD (MX,A,B,C)
      REAL*8 A(MX),B(MX,MX),C(MX)
C     MX  : Size of the matrix
C     A   : Product of a matrix and a vector (B and C)
C     B   : Input matrix
C     C   : Input vector
      DO 11 M=1,MX
        A(M) = 0.0D0
      DO 12 L=1,MX
        A(M) = A(M) + B(M,L) * C(L)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      REAL*8 FUNCTION VABS (MX,A)
      REAL*8 A(MX),S
C     MX  : Size of the vector
C     A   : Input vector
        S = 0.0D0
      DO 11 M=1,MX
        S = S + A(M)**2
   11 CONTINUE
        VABS = DSQRT(S)
      RETURN
      END

      REAL*8 FUNCTION DPRD (MX,A,B)
      REAL*8 A(MX),B(MX)
C     MX  : Size of the vector
C     A,B : Input vectors
        DPRD = 0.0D0
      DO 11 M=1,MX
        DPRD= DPRD + A(M)*B(M)
   11 CONTINUE
      RETURN
      END
