      PARAMETER (LMAX=201,MMAX=201)
      REAL G(LMAX,MMAX),GG(LMAX,MMAX),DM(LMAX,MMAX)
      PARAMETER (DX=1.0E0,DY=1.0E0)

      DO 11 M=1,MMAX
      DO 12 L=1,LMAX
        G(L,M) = 0.0E0
   12 CONTINUE
   11 CONTINUE
        G(141,101) =  1.0E0
        G( 61,101) = -1.0E0
      WRITE(6,*) 'Input field:'
      DO 13 M=201,1,-20
      WRITE(6,'(11F7.3)') (G(1+20*L,M),L=0,10)
   13 CONTINUE

      WRITE(6,*) 'Calculating...'
      CALL POIS (LMAX,MMAX,DX,DY,10000,G,GG,DM,EP)

      WRITE(6,*) 'Output field:'
      DO 21 M=201,1,-20
      WRITE(6,'(11F7.3)') (GG(1+20*L,M),L=0,10)
   21 CONTINUE
      WRITE(6,*) 'Relative error =',EP

      STOP
      END

      SUBROUTINE POIS (LMAX,MMAX,DX,DY,IMAX,G,GG,DM,EP)
      REAL G(LMAX,MMAX),GG(LMAX,MMAX),DM(LMAX,MMAX)
      DO 11 M=1,MMAX
      DO 12 L=1,LMAX
        GG(L,M) = 0.0E0
   12 CONTINUE
   11 CONTINUE
        CX = 1.0E0 / DX**2
        CY = 1.0E0 / DY**2
        C = 1.0E0 / (0.2E1*((1.0E0/DX)**2+(1.0E0/DY)**2))
      DO 21 I=1,IMAX
      SUM1 = 0.0E0
      SUM0 = 0.0E0
      DO 31 M=1,MMAX
      DO 32 L=1,LMAX
      IF (L.EQ.   1) THEN
        DGX = CX * (GG(L+1,M)-0.3E1*GG(L,M))
C        DGX = CX * (GG(L+1,M)+GG(LMAX,M)-0.2E1*GG(L,M))
      ELSE
      IF (L.EQ.LMAX) THEN
        DGX = CX * (GG(L-1,M)-0.3E1*GG(L,M))
C        DGX = CX * (GG(L-1,M)+GG(   1,M)-0.2E1*GG(L,M))
      ELSE
        DGX = CX * (GG(L+1,M)+GG(L-1,M)-0.2E1*GG(L,M))
      ENDIF
      ENDIF
      IF (M.EQ.   1) THEN
        DGY = CY * (GG(L,M+1)-0.3E1*GG(L,M))
      ELSE
      IF (M.EQ.MMAX) THEN
        DGY = CY * (GG(L,M-1)-0.3E1*GG(L,M))
      ELSE
        DGY = CY * (GG(L,M+1)+GG(L,M-1)-0.2E1*GG(L,M))
      ENDIF
      ENDIF
        DG = DGX + DGY
        DG = DG - G(L,M)
      IF (I.EQ.IMAX) THEN
        SUM1 = SUM1 + DG**2
        SUM0 = SUM0 + G(L,M)**2
      ENDIF
        DM(L,M) = C * DG
   32 CONTINUE
   31 CONTINUE
      IF (I.EQ.IMAX) EP = SQRT(SUM1/SUM0)
      DO 41 M=1,MMAX
      DO 42 L=1,LMAX
        GG(L,M) = GG(L,M) + DM(L,M)
   42 CONTINUE
   41 CONTINUE
   21 CONTINUE
      RETURN
      END
