      PARAMETER (LMAX=101,MMAX=101,NMAX=41)
      REAL G(LMAX,MMAX,NMAX),GG(LMAX,MMAX,NMAX),DM(LMAX,MMAX,NMAX)
      PARAMETER (DX=1.0E0,DY=1.0E0,DZ=1.0E0)

      DO 11 N=1,NMAX
      DO 12 M=1,MMAX
      DO 13 L=1,LMAX
        G(L,M,N) = 0.0E0
   13 CONTINUE
   12 CONTINUE
   11 CONTINUE
        G(71,51,21) =  1.0E0
        G(31,51,21) = -1.0E0
      WRITE(6,*) 'Input field (N=21):'
      DO 14 M=101,1,-10
      WRITE(6,'(11F7.3)') (G(1+10*L,M,21),L=0,10)
   14 CONTINUE

      WRITE(6,*) 'Calculating...'
      CALL POIS (LMAX,MMAX,NMAX,DX,DY,DZ,1000,G,GG,DM,EP)

      WRITE(6,*) 'Output field (N=31):'
      DO 21 M=101,1,-10
      WRITE(6,'(11F7.3)') (GG(1+10*L,M,31),L=0,10)
   21 CONTINUE
      WRITE(6,*) 'Output field (N=21):'
      DO 22 M=101,1,-10
      WRITE(6,'(11F7.3)') (GG(1+10*L,M,21),L=0,10)
   22 CONTINUE
      WRITE(6,*) 'Output field (N=11):'
      DO 23 M=101,1,-10
      WRITE(6,'(11F7.3)') (GG(1+10*L,M,11),L=0,10)
   23 CONTINUE
      WRITE(6,*) 'Relative error =',EP

      STOP
      END

      SUBROUTINE POIS (LMAX,MMAX,NMAX,DX,DY,DZ,IMAX,G,GG,DM,EP)
      REAL G(LMAX,MMAX,NMAX),GG(LMAX,MMAX,NMAX),DM(LMAX,MMAX,NMAX)
      DO 11 N=1,NMAX
      DO 12 M=1,MMAX
      DO 13 L=1,LMAX
        GG(L,M,N) = 0.0E0
   13 CONTINUE
   12 CONTINUE
   11 CONTINUE
        CX = 1.0E0 / DX**2
        CY = 1.0E0 / DY**2
        CZ = 1.0E0 / DZ**2
        C = 1.0E0 / (0.2E1*((1.0E0/DX)**2+(1.0E0/DY)**2+(1.0E0/DZ)**2))
      DO 21 I=1,IMAX
      SUM1 = 0.0E0
      SUM0 = 0.0E0
      DO 31 N=1,NMAX
      DO 32 M=1,MMAX
      DO 33 L=1,LMAX
      IF (L.EQ.   1) THEN
        DGX = CX * (GG(L+1,M,N)-0.3E1*GG(L,M,N))
      ELSE
      IF (L.EQ.LMAX) THEN
        DGX = CX * (GG(L-1,M,N)-0.3E1*GG(L,M,N))
      ELSE
        DGX = CX * (GG(L+1,M,N)+GG(L-1,M,N)-0.2E1*GG(L,M,N))
      ENDIF
      ENDIF
      IF (M.EQ.   1) THEN
        DGY = CY * (GG(L,M+1,N)-0.3E1*GG(L,M,N))
      ELSE
      IF (M.EQ.MMAX) THEN
        DGY = CY * (GG(L,M-1,N)-0.3E1*GG(L,M,N))
      ELSE
        DGY = CY * (GG(L,M+1,N)+GG(L,M-1,N)-0.2E1*GG(L,M,N))
      ENDIF
      ENDIF
      IF (N.EQ.   1) THEN
        DGZ = CZ * (GG(L,M,N+1)-0.3E1*GG(L,M,N))
      ELSE
      IF (N.EQ.NMAX) THEN
        DGZ = CZ * (GG(L,M,N-1)-0.3E1*GG(L,M,N))
      ELSE
        DGZ = CZ * (GG(L,M,N+1)+GG(L,M,N-1)-0.2E1*GG(L,M,N))
      ENDIF
      ENDIF
        DG = DGX + DGY + DGZ
        DG = DG - G(L,M,N)
      IF (I.EQ.IMAX) THEN
        SUM1 = SUM1 + DG**2
        SUM0 = SUM0 + G(L,M,N)**2
      ENDIF
        DM(L,M,N) = C * DG
   33 CONTINUE
   32 CONTINUE
   31 CONTINUE
      IF (I.EQ.IMAX) EP = SQRT(SUM1/SUM0)
      DO 41 N=1,NMAX
      DO 42 M=1,MMAX
      DO 43 L=1,LMAX
        GG(L,M,N) = GG(L,M,N) + DM(L,M,N)
   43 CONTINUE
   42 CONTINUE
   41 CONTINUE
   21 CONTINUE
      RETURN
      END
